=== tests/auto/CMakeLists.txt ===
if(TARGET Qt::WebEngineCore)
    add_subdirectory(httpserver)
    add_subdirectory(util)
    add_subdirectory(core)
endif()
if(TARGET Qt::WebEngineQuick)
    add_subdirectory(quick)
endif()
if(TARGET Qt::WebEngineWidgets)
    add_subdirectory(widgets)
endif()
if(TARGET Qt::Pdf)
    add_subdirectory(pdf)
endif()
