=== tests/auto/pdf/qpdfdocument/CMakeLists.txt ===
qt_internal_add_test(tst_qpdfdocument
    SOURCES
        tst_qpdfdocument.cpp
    PUBLIC_LIBRARIES
        Qt::Gui
        Qt::Network
        Qt::PrintSupport
        Qt::Pdf
)
