=== debian/changelog ===
qt6-webengine (6.2.4.1-1+dde) unstable; urgency=medium

  * update to upstream verson 6.2.4
  * set ninja maxjobs num to -j16
  * fit gcc 8.3.0

 -- Ma Aiguo <maaiguo@uniontech.com>  Wed, 15 Jun 2022 13:32:05 +0800

qt6-webengine (6.2.4+dfsg-8) unstable; urgency=medium

  [ Patrick Franz ]
  * Remove lower_libicu_min_to_67.patch as libicu 71 is now available.
  * Make qt6-webengine-dev depend on qt6-webengine-dev-tools as it needs
    it.

 -- Patrick Franz <deltaone@debian.org>  Thu, 26 May 2022 13:27:19 +0200

qt6-webengine (6.2.4+dfsg-7) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Fri, 22 Apr 2022 20:08:01 +0200
